package jturma;

/**
 * Classe turma.
 * 
 * @author Jos Creissac Campos
 * @version 2002
 */

import java.util.*;
public class Turma extends Observable {
    // variveis de instncia


    /**
     * @associates <{Aluno}>
     * @link aggregation*/
    private Hashtable turma;

    // Construtor

    public Turma() {
        this.turma = new Hashtable();
    }

    // Mtodos de instncia

    /**
     * Adicionar um aluno.
     * Se o Aluno j existe,  substituido.
     */
    public void addAluno(Aluno a) {
        Aluno copia = (Aluno)a.clone();
        String num= a.getNumero();
        this.turma.put(num,copia);
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Consultar um aluno
     */
    public Aluno getAluno(String num) throws TurmaException {
        
        try {
            Aluno a = (Aluno)this.turma.get(num);
            return (Aluno)a.clone();
        } 
        catch (NullPointerException e) {
            StringBuffer sb = new StringBuffer("Aluno ");
            sb.append(num);
            sb.append(" inexistente!");
            throw new TurmaException(sb.toString());
        }
    }

    /**
     * Remover um aluno
     */
    public void delAluno(String num) throws TurmaException {
        if (!this.turma.containsKey(num)) {
            StringBuffer sb = new StringBuffer("Aluno ");
            sb.append(num);
            sb.append(" inexistente!");
            throw new TurmaException(sb.toString());
        }        
        this.turma.remove(num);
        this.hasChanged();
        this.notifyObservers();
    }

    /**
     * Quantos alunos passaram
     */
    public int quantosPassam() {
        Enumeration e = this.turma.elements();
        int tot = 0;

        while (e.hasMoreElements()) {
            Aluno a = (Aluno)e.nextElement();
            if (a.getMedia()>=10)
                tot++;
        }
        return tot;
    }
         
}
